    function eta_O = efficiency(x)
   %Innitiating variables
    n = x(1); PD = x(2);  V_a = x(3); T_d = x(4);
    %% TEMP FORDI STYGT
    AeAo = 0.7;
    D = 3;
    Z = 4;
    rho = 1025;
    %% Advance ratio
    if sign(V_a) == -1
        V_a = 0;
    end
    if n < 0.2
        J = 0;
        eta_switch = 0;
    else
        J = V_a*(n*D)^(-1);
        eta_switch = 1;
    end
   %% Kt
    poly_mat_Kt = zeros(39,5);

    poly_mat_Kt(1,1)  = double(0.00880496);
    poly_mat_Kt(2,1)  = double(-0.204554); poly_mat_Kt(2,2) = 1;
    poly_mat_Kt(3,1)  = double(0.166351); poly_mat_Kt(3,3) = 1;
    poly_mat_Kt(4,1)  = double(0.158114); poly_mat_Kt(4,3) = 2;
    poly_mat_Kt(5,1)  = double(-0.147581); poly_mat_Kt(5,2) = 2; poly_mat_Kt(5,4) = 1;
    poly_mat_Kt(6,1)  = double(-0.481497);poly_mat_Kt(6,2) = 1; poly_mat_Kt(6,3) = 1; poly_mat_Kt(6,4) = 1;
    poly_mat_Kt(7,1)  = double(0.415437); poly_mat_Kt(7,3) = 2; poly_mat_Kt(7,4) = 1;
    poly_mat_Kt(8,1)  = double(0.0144043); poly_mat_Kt(8,5) = 1;
    poly_mat_Kt(9,1)  = double(-0.0530054); poly_mat_Kt(9,2) = 2; poly_mat_Kt(9,5) =1;
    poly_mat_Kt(10,1) = double(0.0143481); poly_mat_Kt(10,3) = 1; poly_mat_Kt(10,5) = 1;
    poly_mat_Kt(11,1) = double(0.0606826); poly_mat_Kt(11,2) = 1; poly_mat_Kt(11,3) = 1; poly_mat_Kt(11,5) = 1;
    poly_mat_Kt(12,1) = double(-0.0125894); poly_mat_Kt(12,4) = 1; poly_mat_Kt(12,5) = 1;
    poly_mat_Kt(13,1) = double(0.0109689); poly_mat_Kt(13,2) = 1; poly_mat_Kt(13,4) = 1; poly_mat_Kt(13,5) = 1;
    poly_mat_Kt(14,1) = double(-0.133698); poly_mat_Kt(14,3) = 3;
    poly_mat_Kt(15,1) = double(0.00638407); poly_mat_Kt(15,3) = 6;
    poly_mat_Kt(16,1) = double(-0.00132718); poly_mat_Kt(16,2) = 2; poly_mat_Kt(16,3) = 6;
    poly_mat_Kt(17,1) = double(0.168496); poly_mat_Kt(17,2) = 3; poly_mat_Kt(17,4) = 1;
    poly_mat_Kt(18,1) = double(-0.0507214); poly_mat_Kt(18,4) = 2;
    poly_mat_Kt(19,1) = double(0.0854559); poly_mat_Kt(19,2) = 2; poly_mat_Kt(19,4) = 2;
    poly_mat_Kt(20,1) = double(-0.0504475); poly_mat_Kt(20,2) = 3; poly_mat_Kt(20,4) = 2;
    poly_mat_Kt(21,1) = double(0.010465); poly_mat_Kt(21,2) = 1; poly_mat_Kt(21,3) = 6; poly_mat_Kt(21,4) = 2;
    poly_mat_Kt(22,1) = double(-0.00648272); poly_mat_Kt(22,2) = 2; poly_mat_Kt(22,3) = 6; poly_mat_Kt(22,4) =2;
    poly_mat_Kt(23,1) = double(-0.00841728); poly_mat_Kt(23,3) = 3; poly_mat_Kt(23,5) = 1;
    poly_mat_Kt(24,1) = double(0.0168424); poly_mat_Kt(24,2) = 1; poly_mat_Kt(24,3) = 3; poly_mat_Kt(24,5) = 1;
    poly_mat_Kt(25,1) = double(-0.00102296); poly_mat_Kt(25,2) = 3; poly_mat_Kt(25,3) = 3; poly_mat_Kt(25,5) = 1;
    poly_mat_Kt(26,1) = double(-0.0317791); poly_mat_Kt(26,3) = 3; poly_mat_Kt(26,4) = 1; poly_mat_Kt(26,5) = 1;
    poly_mat_Kt(27,1) = double(0.018604); poly_mat_Kt(27,2) = 1; poly_mat_Kt(27,4) = 2; poly_mat_Kt(27,5) = 1;
    poly_mat_Kt(28,1) = double(-0.00410798); poly_mat_Kt(28,3) = 2; poly_mat_Kt(28,4) = 2; poly_mat_Kt(28,5) = 1;
    poly_mat_Kt(29,1) = double(-0.000606848); poly_mat_Kt(29,5) = 2;
    poly_mat_Kt(30,1) = double(-0.0049819); poly_mat_Kt(30,2) = 1; poly_mat_Kt(30,5) = 2;
    poly_mat_Kt(31,1) = double(0.0025983); poly_mat_Kt(31,2) = 2; poly_mat_Kt(31,5) = 2;
    poly_mat_Kt(32,1) = double(-0.000560528); poly_mat_Kt(32,2) = 3; poly_mat_Kt(32,5) = 2;
    poly_mat_Kt(33,1) = double(-0.00163652); poly_mat_Kt(33,2) = 1; poly_mat_Kt(33,3) = 2; poly_mat_Kt(33,5) = 2;
    poly_mat_Kt(34,1) = double(-0.000328787); poly_mat_Kt(34,2) = 1; poly_mat_Kt(34,3) = 6; poly_mat_Kt(34,5) = 2;
    poly_mat_Kt(35,1) = double(0.000116502); poly_mat_Kt(35,2) = 2; poly_mat_Kt(35,3) = 6; poly_mat_Kt(35,5) = 2;
    poly_mat_Kt(36,1) = double(0.000690904); poly_mat_Kt(36,4) = 1; poly_mat_Kt(36,5) = 2;
    poly_mat_Kt(37,1) = double(0.00421749); poly_mat_Kt(37,3) = 3; poly_mat_Kt(37,4) = 1; poly_mat_Kt(37,5) = 2;
    poly_mat_Kt(38,1) = double(0.0000565229); poly_mat_Kt(38,2) = 3; poly_mat_Kt(38,3) = 6; poly_mat_Kt(38,4) = 1; poly_mat_Kt(38,5) = 2;
    poly_mat_Kt(39,1) = double(-0.00146564); poly_mat_Kt(39,3) = 3; poly_mat_Kt(39,4) = 2; poly_mat_Kt(39,5) = 2;

    temp_storage_Kt = zeros(1,length(poly_mat_Kt));
    for m = 1:length(poly_mat_Kt)
            temp_storage_Kt(m) = poly_mat_Kt(m,1)*J^(poly_mat_Kt(m,2)) ...
                *PD^(poly_mat_Kt(m,3))*AeAo^(poly_mat_Kt(m,4))*Z^(poly_mat_Kt(m,5));
    end

    K_t = sum(temp_storage_Kt);

%     if K_t > 2
%         K_t = 0;
%     elseif sign(K_t) == -1
%         K_t = 0;
%     end
    
    %% K_q
    poly_mat_Kq = zeros(47,5);

    poly_mat_Kq(1,1)  = double(0.00379368);
    poly_mat_Kq(2,1)  = double(0.00886523); poly_mat_Kq(2,2) = 2;
    poly_mat_Kq(3,1)  = double(-0.032241); poly_mat_Kq(3,2) = 1; poly_mat_Kq(3,3) = 1;
    poly_mat_Kq(4,1)  = double(0.00344778); poly_mat_Kq(4,3) = 2;
    poly_mat_Kq(5,1)  = double(-0.0408811); poly_mat_Kq(5,3) = 1; poly_mat_Kq(5,4) = 1;
    poly_mat_Kq(6,1)  = double(-0.108009); poly_mat_Kq(6,2) = 1; poly_mat_Kq(6,3) = 1; poly_mat_Kq(6,4) = 1;
    poly_mat_Kq(7,1)  = double(-0.0885381); poly_mat_Kq(7,2) =2; poly_mat_Kq(7,3) = 1; poly_mat_Kq(7,4) = 1;
    poly_mat_Kq(8,1)  = double(0.188561); poly_mat_Kq(8,3) = 2; poly_mat_Kq(8,4) = 1;
    poly_mat_Kq(9,1)  = double(-0.00370871); poly_mat_Kq(9,2) = 1; poly_mat_Kq(9,5) = 1;
    poly_mat_Kq(10,1) = double(0.00513696); poly_mat_Kq(10,3) = 1; poly_mat_Kq(10,5) = 1;
    poly_mat_Kq(11,1) = double(0.0209449); poly_mat_Kq(11,2) = 1; poly_mat_Kq(11,3) = 1; poly_mat_Kq(11,5) = 1;
    poly_mat_Kq(12,1) = double(0.00474319); poly_mat_Kq(12,2) = 2; poly_mat_Kq(12,3) = 1; poly_mat_Kq(12,5) = 1;
    poly_mat_Kq(13,1) = double(-0.00723408); poly_mat_Kq(13,2) = 2; poly_mat_Kq(13,4) = 1; poly_mat_Kq(13,5) = 1;
    poly_mat_Kq(14,1) = double(0.00438388); poly_mat_Kq(14,2) = 1; poly_mat_Kq(14,3) = 1; poly_mat_Kq(14,4) = 1; poly_mat_Kq(14,5) = 1;
    poly_mat_Kq(15,1) = double(-0.0269403); poly_mat_Kq(15,3) = 2; poly_mat_Kq(15,4) = 1; poly_mat_Kq(15,5) = 1;
    poly_mat_Kq(16,1) = double(0.0558082); poly_mat_Kq(16,2) = 3; poly_mat_Kq(16,4) = 1;
    poly_mat_Kq(17,1) = double(0.0161886); poly_mat_Kq(17,3) = 3; poly_mat_Kq(17,4) = 1;
    poly_mat_Kq(18,1) = double(0.00318086); poly_mat_Kq(18,2) = 1; poly_mat_Kq(18,3) = 3; poly_mat_Kq(18,4) = 1;
    poly_mat_Kq(19,1) = double(0.015896); poly_mat_Kq(19,4) = 2;
    poly_mat_Kq(20,1) = double(0.0471729); poly_mat_Kq(20,2) = 1; poly_mat_Kq(20,4) = 2;
    poly_mat_Kq(21,1) = double(0.0196283); poly_mat_Kq(21,2) = 3; poly_mat_Kq(21,4) = 2;
    poly_mat_Kq(22,1) = double(-0.0502782); poly_mat_Kq(22,3) = 1; poly_mat_Kq(22,4) = 2;
    poly_mat_Kq(23,1) = double(-0.030055); poly_mat_Kq(23,2) = 3; poly_mat_Kq(23,3) = 1; poly_mat_Kq(23,4) = 2;
    poly_mat_Kq(24,1) = double(0.0417122); poly_mat_Kq(24,2) = 2; poly_mat_Kq(24,3) = 2; poly_mat_Kq(24,4) = 2;
    poly_mat_Kq(25,1) = double(-0.0397722); poly_mat_Kq(25,3) = 3; poly_mat_Kq(25,4) = 2;
    poly_mat_Kq(26,1) = double(-0.00350024); poly_mat_Kq(26,3) = 6; poly_mat_Kq(26,4) = 2;
    poly_mat_Kq(27,1) = double(-0.0106854); poly_mat_Kq(27,2) = 3; poly_mat_Kq(27,5) = 1;
    poly_mat_Kq(28,1) = double(0.00110903); poly_mat_Kq(28,2) = 3; poly_mat_Kq(28,3) = 3; poly_mat_Kq(28,5) = 1;
    poly_mat_Kq(29,1) = double(-0.000313912); poly_mat_Kq(29,3) = 6; poly_mat_Kq(29,5) = 1;
    poly_mat_Kq(30,1) = double(0.0035985); poly_mat_Kq(30,2) = 3; poly_mat_Kq(30,4) = 1; poly_mat_Kq(30,5) = 1;
    poly_mat_Kq(31,1) = double(-0.00142121); poly_mat_Kq(31,3) = 6; poly_mat_Kq(31,4) = 1; poly_mat_Kq(31,5) = 1;
    poly_mat_Kq(32,1) = double(-0.00383637); poly_mat_Kq(32,2) = 1; poly_mat_Kq(32,4) = 2; poly_mat_Kq(32,5) = 1;
    poly_mat_Kq(33,1) = double(0.0126803); poly_mat_Kq(33,3) = 2; poly_mat_Kq(33,4) = 2; poly_mat_Kq(33,5) = 1;
    poly_mat_Kq(34,1) = double(-0.00318278); poly_mat_Kq(34,2) = 2; poly_mat_Kq(34,3) = 3; poly_mat_Kq(34,4) = 2; poly_mat_Kq(34,5) = 1;
    poly_mat_Kq(35,1) = double(0.00334268); poly_mat_Kq(35,3) = 6; poly_mat_Kq(35,4) = 2; poly_mat_Kq(35,5) =1;
    poly_mat_Kq(36,1) = double(-0.00183491); poly_mat_Kq(36,2) = 1; poly_mat_Kq(36,3) = 1; poly_mat_Kq(36,5) = 2;
    poly_mat_Kq(37,1) = double(0.000112451); poly_mat_Kq(37,2) = 3; poly_mat_Kq(37,3) = 2; poly_mat_Kq(37,5) = 2;
    poly_mat_Kq(38,1) = double(-0.0000297228); poly_mat_Kq(38,2) = 3; poly_mat_Kq(38,3) = 6; poly_mat_Kq(38,5) = 2;
    poly_mat_Kq(39,1) = double(0.000269551); poly_mat_Kq(39,2) = 1; poly_mat_Kq(39,4) = 1; poly_mat_Kq(39,5) = 2;
    poly_mat_Kq(40,1) = double(0.00083265); poly_mat_Kq(40,2) = 2; poly_mat_Kq(40,4) = 1; poly_mat_Kq(40,5) = 2;
    poly_mat_Kq(41,1) = double(0.00155334); poly_mat_Kq(41,3) = 2; poly_mat_Kq(41,4) = 1; poly_mat_Kq(41,5) = 2;
    poly_mat_Kq(42,1) = double(0.000302683); poly_mat_Kq(42,3) = 6; poly_mat_Kq(42,4) = 1; poly_mat_Kq(42,5) = 2;
    poly_mat_Kq(43,1) = double(-0.0001843) ; poly_mat_Kq(43,4) = 2; poly_mat_Kq(43,5) = 2;
    poly_mat_Kq(44,1) = double(-0.000425399); poly_mat_Kq(44,3) = 3; poly_mat_Kq(44,4) = 2; poly_mat_Kq(44,5) = 2;
    poly_mat_Kq(45,1) = double(0.0000869243); poly_mat_Kq(45,2) = 3; poly_mat_Kq(45,3) = 3; poly_mat_Kq(45,4) = 2; poly_mat_Kq(45,5) = 2;
    poly_mat_Kq(46,1) = double(-0.0004659); poly_mat_Kq(46,3) = 6; poly_mat_Kq(46,4) = 2; poly_mat_Kq(46,5) = 2;
    poly_mat_Kq(47,1) = double(0.0000554194); poly_mat_Kq(47,2) = 1; poly_mat_Kq(47,3) = 6; poly_mat_Kq(47,4) = 2; poly_mat_Kq(47,5) = 2;


    temp_storage_Kq = zeros(1,length(poly_mat_Kq));
    for m = 1:length(poly_mat_Kq)
            temp_storage_Kq(m) = poly_mat_Kq(m,1)*J^(poly_mat_Kq(m,2)) ...
                *PD^(poly_mat_Kq(m,3))*AeAo^(poly_mat_Kq(m,4))*Z^(poly_mat_Kq(m,5));
    end

    K_q = sum(temp_storage_Kq);

%     if K_q > 2
%         K_q = 0;
%     elseif sign(K_q) == -1
%         K_q = 100000;
%     end
    
    %% Open water efficiency
        
    eta_O = -((J/(2*pi))*(K_t/K_q))*eta_switch;
 
    
end