%% Constants:
    warning('off');
    load supply.mat;
    load supplyABC.mat;

    t0 = 0;
    dt = 0.1;
    t1 = 250;
    
    t = t0:dt:t1; 

    states0 = zeros(6,1);
    states0(1) = 0.01;
    states0(6) = 1;
 
    vs_sine = 2+0.5*sin(0.05*t);
    vs_step = heaviside(t-5)*5;
    
  
    prop = propeller(0,1,0);

    supply_boat = ship(0,0,0,vessel,vesselABC);

    speed_ctrl = speed_controller;

    electric_motor = engine;
    electric_motor.Qm = 0;

    consolidated_ctrl = consolidated_controller_c(-354,-345);
    
    advance_speed_estimator = estimator(-666,-666,-666);